import 'package:flutter/animation.dart';
import 'package:flutter/material.dart';

class PIA_Animation
{
   static Widget Translate_X(double form_x,double to_x,Widget view)
   {  return PIA_Animation_StatefulWidget(value_1:form_x,value_2:to_x,direction:1,child:view,start: true,); }

   static Widget Translate_Y(double form_y,double to_y,Widget view)
   { print("Trasn Y");
     return PIA_Animation_StatefulWidget(value_1:form_y,value_2:to_y,direction:2,child:view,start:true); }

   static Widget Goto(double x,double y,Widget view) {
     print("View Goto");
     return  new Container(
           margin: EdgeInsets.only(top: y, left: x),
           child: view,
     );
   }
}



class PIA_Animation_StatefulWidget extends StatefulWidget {
  double value_1;
  double value_2;
  int direction = 1; //1 = X , 2 = Y
  Widget child;
  bool start = true;

  PIA_Animation_StatefulWidget({Key key, this.value_1,this.value_2,this.direction,this.child,this.start}): super(key: key);
  _PIA_Animation_StatefulWidget_State createState()
    {  return _PIA_Animation_StatefulWidget_State(); }


}


// #docregion print-state
class _PIA_Animation_StatefulWidget_State extends State<PIA_Animation_StatefulWidget> with SingleTickerProviderStateMixin  {

  double top = 0;
  double left = 0;
  AnimationController controller;

  @override
  void didChangeDependencies()
  { print("did change ");}

  @override
  void deactivate()
  { print("Deactivate ");}


  @override
  void initState() {
    print("Animate state init");
    super.initState();

    controller = AnimationController(duration: const Duration(milliseconds: 200),
        vsync: this)
      ..addListener(() {
        this.setState(() {
             double  offset = 0;

             if(widget.value_1 > widget.value_2)
                {  offset = widget.value_1  - (widget.value_1 - widget.value_2) * controller.value; }
              else
                {  offset =  widget.value_1 + (widget.value_2 - widget.value_1) * controller.value;  }

             if(widget.direction == 1)
               {  top = 0; left = offset; }
              else
                { top = offset; left = 0; }

             print("Offset $offset ${widget.value_1}  ${widget.value_2}");

        });
      });

   }


  @override
  Widget build(BuildContext context) {
    print("Container build ${widget.start}");

    if(widget.start) {
      print("Start value ${widget.value_1}  ${widget.value_2}");
      controller.forward(from:0);
      widget.start = false;
    }

    return new Container(
          margin: EdgeInsets.only(top: top,left:left),
          child: widget.child,
    );
  }

  @override
  void dispose() {
    print("dispose");
    controller.dispose();
    super.dispose();
  }

}

