import 'dart:io';

import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class PIA_Image extends StatelessWidget
{  static var box_contain = BoxFit.contain;
   static var box_cover = BoxFit.cover;

   String image_path;
   double width = 300;
   double height = 300;
   double round = 0;
   BoxFit boxfit = BoxFit.cover;

   PIA_Image(this.image_path,this.width,this.height,this.round,this.boxfit);

   @override
   Widget build(BuildContext context) {
     if(image_path.isEmpty)
       {  return Container(); }

     if (image_path.contains("http")) {
       return
         new ClipRRect(

           borderRadius: new BorderRadius.circular(round),
           child: new CachedNetworkImage(
             width: (width == 0) ? null : width,
             height: (height == 0) ? null : height,
             imageUrl: image_path,
             placeholder: (context, url) => new CircularProgressIndicator(),
             errorWidget: (context, url, error) => new Icon(Icons.error),
             fit: boxfit,
           ),
         );
     }
     else if (image_path.contains("Asset/Image/")) {
       return
         new ClipRRect(
             borderRadius: new BorderRadius.circular(round),
             child: Image.asset(image_path,
               width: (width == 0) ? null : width,
               height: (height == 0) ? null : height,
               fit: boxfit,
             )
         );
     }
     else {
       print("Return $image_path" );
       return new ClipRRect(
           borderRadius: new BorderRadius.circular(round),
           child: Image.file(new File(image_path),
             width: (width == 0) ? null : width,
             height: (height == 0) ? null : height,
             fit: boxfit,
           )
       );

     }
   }

}
