import 'dart:io' ;
import 'package:flutter/material.dart';
import 'package:flutter_document_picker/flutter_document_picker.dart';

import 'package:image_picker/image_picker.dart';
import 'package:image_crop/image_crop.dart';
import 'package:pia_framework/Variable/PIA_Global.dart';
import 'package:pia_framework/View/PIA_Page.dart';
import 'package:pia_framework/Image/PIA_ImageCrop_Page.dart';
import 'package:pia_framework/Lang/PIA_Lang.dart';

class PIA_ImagePicker_CallBack
{   void Image_Picker_Callback(File image){} }

class PIA_ImagePicker
{

   static PIA_ImagePicker_CallBack _callback;
   static BuildContext _context;
   static bool _iscrop = false;
   static int _maxwidth = 0;


  static void show_bottom_sheet(BuildContext context,PIA_ImagePicker_CallBack callback,bool iscrop,int maxwidth,bool hasfile){
      _context = context;
      _callback = callback;
      _iscrop = iscrop;
      _maxwidth = maxwidth;

      showModalBottomSheet(
      context: context,
      builder: (BuildContext context){
        return  Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            new ListTile(
              leading: new Icon(Icons.camera),
              title: new Text(camera[PIA_Lang.lang_id]),
              onTap: () {  Navigator.pop(context); _getCamera(); }
            ),
            new ListTile(
              leading: new Icon(Icons.photo_library),
              title: new Text(photo[PIA_Lang.lang_id]),
              onTap: () {  Navigator.pop(context);  _getImage(); }
            ),
            (hasfile) ? new ListTile(
                leading: new Icon(Icons.folder_open),
                title: new Text(file[PIA_Lang.lang_id]),
                onTap: () {  Navigator.pop(context);  _getFile(); }
            ): new Container(height: 0,)
          ],
        );
      }
  );}




   static Future _getImage() async {
     var image = await ImagePicker.pickImage(source: ImageSource.gallery);
     if (_callback != null && image != null) {
          _get_image(image);
     }}

   static Future _getCamera() async {
     var image = await ImagePicker.pickImage(source: ImageSource.camera);
     if (_callback != null && image != null) {
         _get_image(image);
   }}

  static Future _getFile() async {
    final path = await FlutterDocumentPicker.openDocument();
     if (_callback != null && path != null) {
       _callback.Image_Picker_Callback(File(path.toString()));
    }}


   static Future _get_image(File image) async {
     print("IsCrop : " + _iscrop.toString());

     if (_iscrop) {
          var decodedImage = await decodeImageFromList(image.readAsBytesSync());
          double crop_maxvalue = (decodedImage.height * 100.0 / decodedImage.width * 100.0)/10000.0;
          print("Crop Maxvalue $crop_maxvalue");
          PIA_Page.new_page(_context, PIA_ImageCrop_Page(imagefile: image,callback:_callback,maxwidth:_maxwidth, maximumScale: crop_maxvalue));
     }
     else {
       if(_maxwidth > 0 ) {
         final sampleFile = await ImageCrop.sampleImage(
             file: image,
             preferredWidth: _maxwidth,
             preferredHeight: _maxwidth);
         _callback.Image_Picker_Callback(sampleFile);
       }
      else
        { _callback.Image_Picker_Callback(image); }
     }
   }




}