import 'package:dio/src/dio_error.dart';
import 'package:flutter/material.dart';
import 'package:stripe_payment/stripe_payment.dart';
import 'package:pia_framework/API/PIA_API_Popup.dart';
import 'package:pia_framework/Popup/PIA_Alert.dart';
import 'package:pia_framework/Func/PIA_Func.dart';
import 'package:pia_framework/Lang/PIA_Lang.dart';
import 'package:pia_framework/Variable/PIA_Global.dart';

class PIA_Strip_CallBack
{  void Pay_Success(Map<String,dynamic> json){} }


class PIA_Strip implements PIA_API_CallBack
{ static String HK = "hkd";
  static String US = "usd";

  String _currency = "hkd";
  PIA_Strip_CallBack callback;

  PIA_Strip(String Publishable_Key,this._currency,this.callback) {
    StripeSource.setPublishableKey(Publishable_Key);
  }

  Future paynow(BuildContext context,String api_url,Map<String,String> post, double amount)
    async {  var network = await PIA_Func.Check_network();
    if(!network) {
      PIA_Alert.Error(context,api_error[PIA_Lang.lang_id],api_nonetwork[PIA_Lang.lang_id]);
      return;
    }


    StripeSource.addSource().then((String token) {
        print("Pay Strip : $token"); //your stripe card source token
        post["strip_token"] = token;
        post["currency"] = this._currency;
        post["lang"] = PIA_Lang.lang_id;
        post["amount"] = amount.toString();
        PIA_API_Popup.Post(context, api_url, post, this);
      });
    }

  @override
  void API_Error(DioErrorType error) {
    // TODO: implement API_Error
  }

  @override
  void API_Success(Map<String,dynamic > json, List j) {
    if(callback != null)
      { callback.Pay_Success(json); }
  }

  @override
  void API_Upload_prodcess(int upload, int total) {
    // TODO: implement API_Upload_prodcess
  }

}
