import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:pia_framework/Func/PIA_Animation.dart';

//Example
/*
class Example extends StatelessWidget {
/
  final PIA_UpDown_View_Controller updown_controller = PIA_UpDown_View_Controller();
  Example({ Key key }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
          backgroundColor: Colors.deepOrange,
          title: Text("Stateless")
      ),
      body:
      PIA_UpDown_View(
          y1:100,
          y2:200,
          default_status: PIA_UpDown_View.Status_Up,
          controller: updown_controller,
          child:Container(
              width: double.infinity,
              height: 2000,
              color: Colors.blue,
              child: Column(
                children: <Widget>[
                  SizedBox(height:100),
                  new Row(
                      children: <Widget>[
                        RaisedButton(
                            child: Text("up"),
                            onPressed: () { updown_controller.up();} ),
                        RaisedButton(
                            child: Text("down"),
                            onPressed: () { updown_controller.down();} ),
                      ]
                  ),

                ],
              ))),

    );
  }
}
*/


class PIA_UpDown_View_Controller
{  _PIA_UpDown_View_State updownstate;
   up(){ updownstate.up();  }
   down(){  updownstate.down(); }
}


class PIA_UpDown_View extends StatefulWidget {
  static int Status_Up = 1;
  static int Status_Down = 1;

  final int direction = 2; //1 = X , 2 = Y

  double y1;
  double y2;
  Widget child;
  int default_status = 2; //
  PIA_UpDown_View_Controller controller;

  PIA_UpDown_View({Key key,@required this.y1, @required this.y2,@required this.child,@required this.default_status,@required this.controller})
      : super(key: key);

  _PIA_UpDown_View_State createState()=>_PIA_UpDown_View_State();
}


// #docregion print-state
class _PIA_UpDown_View_State extends State<PIA_UpDown_View> {
  double y1;
  double y2;

  int current_status = 2;
  int change_status = 0;

  @override
  void initState()
  { super.initState();
    widget.controller.updownstate = this;
    y1 = widget.y1;
    y2 = widget.y2;
    current_status = widget.default_status;
    change_status = 0;
  }

  up()
  {  if(current_status == 2) {
    setState(() {
      change_status = 1;
    });
  }}

  down()
  {  if(current_status == 1) {
    setState(() {
      change_status = 2;
    });
  }}

  @override
  Widget build(BuildContext context) {
    print("Build PIA_UpDown");

          switch (change_status) {
            case 0:
              if (current_status == 1) {
                return PIA_Animation.Goto(0, y1, widget.child);
              }
              else {
                return PIA_Animation.Goto(0, y2, widget.child);
              }
              break;

            case 1: // going Up
              current_status = 1;
              return PIA_Animation.Translate_Y(y2, y1, widget.child);
              break;

            case 2: // going Down
              current_status = 2;
              return PIA_Animation.Translate_Y(y1, y2, widget.child);
              break;
          }
        }



}


/*
class PIA_UpDown_View extends StatefulWidget {
  static int Status_Up = 1;
  static int Status_Down = 1;

  final int direction = 2; //1 = X , 2 = Y

  double y1;
  double y2;
  Widget child;
  int updown_status = 2 ; //
  PIA_UpDown_View_Controller controller;

  PIA_UpDown_View({Key key, this.y1,this.y2,this.child,this.updown_status,this.controller}): super(key: key);
  _PIA_UpDown_View_State createState() => _PIA_UpDown_View_State();

}



// #docregion print-state
class _PIA_UpDown_View_State extends State<PIA_UpDown_View> {
  int view_status = 0; // 0 = not init,  1 = up , 2 = down

  @override
  Widget build(BuildContext context) {
    switch (view_status) {
      case 0:
        if (widget.updown_status == 1) {
          view_status = 1;
          return PIA_Animation.Goto(0, widget.y1, widget.child);
        }
        else {
          view_status = 2;
          return PIA_Animation.Goto(0, widget.y2, widget.child);
        }
        break;

      case 1:
        PIA_Animation.Translate_Y(widget.y2, widget.y1, widget.child);
        break;

      case 2:
        PIA_Animation.Translate_Y(widget.y1, widget.y2, widget.child);
        break;
    }
  }
}

*/
